from typing import Sequence, Literal


class AlignmentOperation: ...


class Match(AlignmentOperation):
    def __new__(cls) -> Match: ...
    def __hash__(self) -> int: ...
    def __eq__(self, other: Match) -> bool: ...
    def __ne__(self, other: Match) -> bool: ...
    def __repr__(self) -> str: ...


class Subst(AlignmentOperation):
    def __new__(cls) -> Subst: ...
    def __hash__(self) -> int: ...
    def __eq__(self, other: Subst) -> bool: ...
    def __ne__(self, other: Subst) -> bool: ...
    def __repr__(self) -> str: ...


class Del(AlignmentOperation):
    def __new__(cls) -> Del: ...
    def __hash__(self) -> int: ...
    def __eq__(self, other: Del) -> bool: ...
    def __ne__(self, other: Del) -> bool: ...
    def __repr__(self) -> str: ...


class Ins(AlignmentOperation):
    def __new__(cls) -> Ins: ...
    def __hash__(self) -> int: ...
    def __eq__(self, other: Ins) -> bool: ...
    def __ne__(self, other: Ins) -> bool: ...
    def __repr__(self) -> str: ...


class Xclip(AlignmentOperation):
    def __new__(cls, x: int) -> Xclip: ...
    def __hash__(self) -> int: ...
    def __eq__(self, other: Xclip) -> bool: ...
    def __ne__(self, other: Xclip) -> bool: ...
    def __repr__(self) -> str: ...


class Yclip(AlignmentOperation):
    def __new__(cls, y: int) -> Yclip: ...
    def __hash__(self) -> int: ...
    def __eq__(self, other: Yclip) -> bool: ...
    def __ne__(self, other: Yclip) -> bool: ...
    def __repr__(self) -> str: ...


class Alignment:
    def __new__(
            cls,
            score: int,
            x_start: int,
            y_start: int,
            x_end: int,
            y_end: int,
            x_len: int,
            y_len: int,
            operations: Sequence[AlignmentOperation],
            mode: Literal['local', 'semiglobal', 'global', 'custom'] = 'global',
    ) -> Alignment: ...
    def __repr__(self) -> str: ...
    def cigar(self, hard_clip: bool) -> str: ...
    def pretty(self, x: bytes, y: bytes) -> str: ...
    def path(self) -> tuple[int, int, AlignmentOperation]: ...
